package com.yuxingwang.gantt.demo.tabs;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import com.yuxingwang.gantt.Config;


/**
* @deprecated 
*/
public class ColorTab extends JPanel {

	private Config config = null;  //  @jve:decl-index=0:
	private static final long serialVersionUID = 1L;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel11 = null;
	private JLabel jLabel111 = null;
	private JLabel jLabel112 = null;
	private JLabel jLabel113 = null;
	private JLabel jLabel114 = null;
	private JLabel jLabel3;
	private JLabel jLabel2;
	private JLabel jLabel1141 = null;
	private JLabel jLabel12asd = null;
	private JLabel lblGanttChartBackcolorSample = null;
	private JLabel lblWorkingTimeColorSample = null;
	private JLabel lblRestoutColorSample = null;
	private JLabel lblKickoffTimeColorSample = null;
	private JLabel lblDeadlineColorSample = null;
	private JLabel lblTaskGroupBarColorSample = null;
	private JLabel lblTaskBarColorSample = null;
	private JLabel lblSelectedTaskRowSample;
	private JLabel lblCurrentTimeColorSample;
	private JLabel lblProgressBarColorSample = null;
	private JLabel lblTaskTreeViewColorSample = null;
	public ColorTab() {
		initialize();
	}
		

	public ColorTab(LayoutManager layout) {
		super(layout);
		initialize();
	}

	public ColorTab(boolean isDoubleBuffered) {
		super(isDoubleBuffered);
		initialize();
	}

	public ColorTab(LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        lblTaskTreeViewColorSample = new JLabel();
        lblTaskTreeViewColorSample.setBounds(231, 180, 186, 25);
        lblTaskTreeViewColorSample.setName("");
        lblTaskTreeViewColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblTaskTreeViewColorSample.setOpaque(true);
        lblTaskTreeViewColorSample.setText("");
        lblTaskTreeViewColorSample.setBackground(Color.black);
        lblTaskTreeViewColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblTaskTreeViewColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblTaskTreeViewColorSample.setVisible(true);
        lblTaskTreeViewColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the task tree view", lblTaskGroupBarColorSample.getBackground());
				if(newColor != null){
					lblTaskTreeViewColorSample.setBackground(newColor);
					lblTaskTreeViewColorSample.setText(formatColor(newColor));
					config.setTaskTreeViewBackColor(newColor);
				}
        	}
        });
        jLabel12asd = new JLabel();
        jLabel12asd.setBounds(4, 180, 217, 25);
        jLabel12asd.setText("Backcolor of task tree view");
        jLabel12asd.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel12asd.setVisible(true);
        lblProgressBarColorSample = new JLabel();
        lblProgressBarColorSample.setBounds(659, 75, 186, 25);
        lblProgressBarColorSample.setName("");
        lblProgressBarColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblProgressBarColorSample.setOpaque(true);
        lblProgressBarColorSample.setText("");
        lblProgressBarColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblProgressBarColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblProgressBarColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblProgressBarColorSample.setBackground(Color.black);
        lblProgressBarColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the progress bar", lblProgressBarColorSample.getBackground());
				if(newColor != null){
					lblProgressBarColorSample.setBackground(newColor);
					lblProgressBarColorSample.setText(formatColor(newColor));
					config.setProgressBarBackColor(newColor);
				}
        	}
        });
        jLabel1141 = new JLabel();
        jLabel1141.setBounds(436, 75, 217, 25);
        jLabel1141.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel1141.setText("Color of the progress bar");
        lblTaskBarColorSample = new JLabel();
        lblTaskBarColorSample.setBounds(659, 40, 186, 25);
        lblTaskBarColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the task bar", lblTaskBarColorSample.getBackground());
				if(newColor != null){
					lblTaskBarColorSample.setBackground(newColor);
					lblTaskBarColorSample.setText(formatColor(newColor));
					config.setTaskBarBackColor(newColor);
				}
        	}
        });
        lblTaskBarColorSample.setName("");
        lblTaskBarColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblTaskBarColorSample.setOpaque(true);
        lblTaskBarColorSample.setText("");
        lblTaskBarColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblTaskBarColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblTaskBarColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblTaskBarColorSample.setBackground(new Color(102, 153, 255));
        lblTaskGroupBarColorSample = new JLabel();
        lblTaskGroupBarColorSample.setBounds(659, 5, 186, 25);
        lblTaskGroupBarColorSample.setName("");
        lblTaskGroupBarColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblTaskGroupBarColorSample.setOpaque(true);
        lblTaskGroupBarColorSample.setText("");
        lblTaskGroupBarColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblTaskGroupBarColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblTaskGroupBarColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblTaskGroupBarColorSample.setBackground(Color.black);
        lblTaskGroupBarColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the task group bar", lblTaskGroupBarColorSample.getBackground());
				if(newColor != null){
					lblTaskGroupBarColorSample.setBackground(newColor);
					lblTaskGroupBarColorSample.setText(formatColor(newColor));
					config.setTaskGroupBarBackColor(newColor);
				}
        	}
        });
        lblDeadlineColorSample = new JLabel();
        lblDeadlineColorSample.setBounds(231, 145, 186, 25);
        lblDeadlineColorSample.setName("");
        lblDeadlineColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblDeadlineColorSample.setOpaque(true);
        lblDeadlineColorSample.setText("");
        lblDeadlineColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblDeadlineColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblDeadlineColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblDeadlineColorSample.setBackground(new Color(255, 153, 204));
        lblDeadlineColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the working end time", lblDeadlineColorSample.getBackground());
				if(newColor != null){
					lblDeadlineColorSample.setBackground(newColor);
					lblDeadlineColorSample.setText(formatColor(newColor));
					config.setDeadlineBackColor(newColor);
				}
        	}
        });
        lblKickoffTimeColorSample = new JLabel();
        lblKickoffTimeColorSample.setBounds(231, 110, 186, 25);
        lblKickoffTimeColorSample.setName("");
        lblKickoffTimeColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblKickoffTimeColorSample.setOpaque(true);
        lblKickoffTimeColorSample.setText("");
        lblKickoffTimeColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblKickoffTimeColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblKickoffTimeColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblKickoffTimeColorSample.setBackground(Color.cyan);
        lblKickoffTimeColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of working start time", lblKickoffTimeColorSample.getBackground());
				if(newColor != null){
					lblKickoffTimeColorSample.setBackground(newColor);
					lblKickoffTimeColorSample.setText(formatColor(newColor));
					config.setKickoffTimeBackColor(newColor);
				}
        	}
        });
        lblRestoutColorSample = new JLabel();
        lblRestoutColorSample.setBounds(231, 75, 186, 25);
        lblRestoutColorSample.setName("");
        lblRestoutColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblRestoutColorSample.setOpaque(true);
        lblRestoutColorSample.setText("");
        lblRestoutColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblRestoutColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblRestoutColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblRestoutColorSample.setBackground(Color.gray);
        lblRestoutColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the rest-out time", lblRestoutColorSample.getBackground());
				if(newColor != null){
					lblRestoutColorSample.setBackground(newColor);
					lblRestoutColorSample.setText(formatColor(newColor));
					config.setRestoutTimeBackColor(newColor);
				}
        	}
        });
        lblWorkingTimeColorSample = new JLabel();
        lblWorkingTimeColorSample.setBounds(231, 40, 186, 25);
        lblWorkingTimeColorSample.setText("");
        lblWorkingTimeColorSample.setName("");
        lblWorkingTimeColorSample.setOpaque(true);
        lblWorkingTimeColorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblWorkingTimeColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblWorkingTimeColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblWorkingTimeColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblWorkingTimeColorSample.setBackground(Color.white);
        lblWorkingTimeColorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the working time", lblWorkingTimeColorSample.getBackground());
				if(newColor != null){
					lblWorkingTimeColorSample.setBackground(newColor);
					lblWorkingTimeColorSample.setText(formatColor(newColor));
					config.setWorkingTimeBackColor(newColor);
				}
        	}
        });
        jLabel114 = new JLabel();
        jLabel114.setBounds(436, 40, 217, 25);
        jLabel114.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel114.setText("Color of the task bar");
        jLabel113 = new JLabel();
        jLabel113.setBounds(436, 5, 217, 25);
        jLabel113.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel113.setText("Color of the task group bar");
        jLabel112 = new JLabel();
        jLabel112.setBounds(4, 145, 217, 25);
        jLabel112.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel112.setText("Backcolor of the deadline");
        jLabel111 = new JLabel();
        jLabel111.setBounds(4, 110, 217, 25);
        jLabel111.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel111.setText("Backcolor of the kickoff time");
        jLabel11 = new JLabel();
        jLabel11.setBounds(4, 75, 217, 25);
        jLabel11.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel11.setText("Backcolor of the rest-out time");
        jLabel1 = new JLabel();
        jLabel1.setBounds(4, 40, 217, 25);
        jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel1.setText("Backcolor of the working time");
        lblGanttChartBackcolorSample = new JLabel();
        lblGanttChartBackcolorSample.setBounds(231, 5, 186, 25);
        lblGanttChartBackcolorSample.setBackground(new Color(237, 246, 247));
        lblGanttChartBackcolorSample.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
        lblGanttChartBackcolorSample.setOpaque(true);
        lblGanttChartBackcolorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        lblGanttChartBackcolorSample.setHorizontalAlignment(SwingConstants.CENTER);
        lblGanttChartBackcolorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        lblGanttChartBackcolorSample.setText("");
        lblGanttChartBackcolorSample.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseClicked(java.awt.event.MouseEvent e) {
        		System.out.println("mouseClicked()"); 
				Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the Gantt chart", lblGanttChartBackcolorSample.getBackground());
				if(newColor != null){
					lblGanttChartBackcolorSample.setBackground(newColor);
					lblGanttChartBackcolorSample.setText(formatColor(newColor));
					config.setGanttChartBackColor(newColor);
				}
        	}
        });
        jLabel = new JLabel();
        jLabel.setBounds(4, 5, 217, 25);
        jLabel.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabel.setText("Backcolor of the Gantt chart");
        this.setLayout(null);
        this.setSize(new Dimension(681, 281));
        this.setPreferredSize(new java.awt.Dimension(870, 281));
        this.add(jLabel, null);
        this.add(lblGanttChartBackcolorSample, null);
        this.add(jLabel1, null);
        this.add(jLabel11, null);
        this.add(jLabel111, null);
        this.add(jLabel112, null);
        this.add(jLabel113, null);
        this.add(jLabel114, null);
        this.add(lblWorkingTimeColorSample, null);
        this.add(lblRestoutColorSample, null);
        this.add(lblKickoffTimeColorSample, null);
        this.add(lblDeadlineColorSample, null);
        this.add(lblTaskGroupBarColorSample, null);
        this.add(lblTaskBarColorSample, null);
        this.add(jLabel1141, null);
        this.add(lblProgressBarColorSample, null);
        this.add(jLabel12asd, null);
        this.add(lblTaskTreeViewColorSample, null);
        {
        	jLabel2 = new JLabel();
        	this.add(jLabel2);
        	jLabel2.setText("Backcolor of current time");
        	jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
        	jLabel2.setBounds(4, 215, 217, 25);
        }
        {
        	lblCurrentTimeColorSample = new JLabel();
        	this.add(lblCurrentTimeColorSample);
        	lblCurrentTimeColorSample.setText("");
        	lblCurrentTimeColorSample.setHorizontalAlignment(SwingConstants.CENTER);
        	lblCurrentTimeColorSample.setHorizontalTextPosition(SwingConstants.CENTER);
        	lblCurrentTimeColorSample.setBackground(Color.black);
        	lblCurrentTimeColorSample.setBorder(BorderFactory.createLineBorder(Color.gray,1));
        	lblCurrentTimeColorSample.setOpaque(true);
        	lblCurrentTimeColorSample.setName("lblCurrentTimeColorSample");
        	lblCurrentTimeColorSample.setBounds(231, 215, 186, 25);
        	lblCurrentTimeColorSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        	lblCurrentTimeColorSample.addMouseListener(new MouseAdapter() {
        		public void mouseClicked(MouseEvent e) {
        			System.out.println("mouseClicked()"); 
        			Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the progress bar", lblProgressBarColorSample.getBackground());
        			if(newColor != null){
        				lblCurrentTimeColorSample.setBackground(newColor);
        				lblCurrentTimeColorSample.setText(formatColor(newColor));
        				config.setCurrentTimeBackColor(newColor);
        			}
        		}
        	});
        }
        {
        	jLabel3 = new JLabel();
        	this.add(jLabel3);
        	jLabel3.setText("Color of selected task row");
        	jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
        	jLabel3.setBounds(436, 110, 217, 25);
        }
        {
        	lblSelectedTaskRowSample = new JLabel();
        	this.add(lblSelectedTaskRowSample);
        	lblSelectedTaskRowSample.setText("");
        	lblSelectedTaskRowSample.setHorizontalAlignment(SwingConstants.CENTER);
        	lblSelectedTaskRowSample.setHorizontalTextPosition(SwingConstants.CENTER);
        	lblSelectedTaskRowSample.setBackground(new java.awt.Color(255,175,175));
        	lblSelectedTaskRowSample.setOpaque(true);
        	lblSelectedTaskRowSample.setBorder(BorderFactory.createLineBorder(Color.gray,1));
        	lblSelectedTaskRowSample.setName("lblSelectedTaskRowSample");
        	lblSelectedTaskRowSample.setBounds(657, 110, 186, 25);
        	lblSelectedTaskRowSample.setCursor(new Cursor(Cursor.HAND_CURSOR));
        	lblSelectedTaskRowSample.addMouseListener(new MouseAdapter() {
        		public void mouseClicked(MouseEvent e) {
        			System.out.println("mouseClicked()"); 
        			Color newColor = JColorChooser.showDialog((JComponent)e.getSource(), "Choose color for background of the progress bar", lblProgressBarColorSample.getBackground());
        			if(newColor != null){
        				lblSelectedTaskRowSample.setBackground(newColor);
        				lblSelectedTaskRowSample.setText(formatColor(newColor));
        				config.setSelectionColor(newColor);
        			}
        		}
        	});
        }

	}
	
	/**
	 * Use this method to init colors of tab from the Config.
	 * @param config
	 */
	public void setColorConfig(Config config){
		this.config = config;
		//Background color
		this.lblGanttChartBackcolorSample.setBackground(config.getGanttChartBackColor());
		this.lblWorkingTimeColorSample.setBackground(config.getWorkingTimeBackColor());
		this.lblRestoutColorSample.setBackground(config.getRestoutTimeBackColor());
		this.lblKickoffTimeColorSample.setBackground(config.getKickoffTimeBackColor());
		this.lblDeadlineColorSample.setBackground(config.getDeadlineBackColor());
		this.lblTaskGroupBarColorSample.setBackground(config.getTaskGroupBarBackColor());
		this.lblTaskBarColorSample.setBackground(config.getTaskBarBackColor());
		this.lblProgressBarColorSample.setBackground(config.getProgressBarBackColor());
		this.lblTaskTreeViewColorSample.setBackground(config.getTaskTreeViewBackColor());
		this.lblCurrentTimeColorSample.setBackground(config.getCurrentTimeBackColor());
		this.lblSelectedTaskRowSample.setBackground(config.getSelectionColor());
		// Text
		this.lblGanttChartBackcolorSample.setText(formatColor(config.getGanttChartBackColor()));
		this.lblWorkingTimeColorSample.setText(formatColor(config.getWorkingTimeBackColor()));
		this.lblRestoutColorSample.setText(formatColor(config.getRestoutTimeBackColor()));
		this.lblKickoffTimeColorSample.setText(formatColor(config.getKickoffTimeBackColor()));
		this.lblDeadlineColorSample.setText(formatColor(config.getDeadlineBackColor()));
		this.lblTaskGroupBarColorSample.setText(formatColor(config.getTaskGroupBarBackColor()));
		this.lblTaskBarColorSample.setText(formatColor(config.getTaskBarBackColor()));
		this.lblProgressBarColorSample.setText(formatColor(config.getProgressBarBackColor()));
		this.lblTaskTreeViewColorSample.setText(formatColor(config.getTaskTreeViewBackColor()));
		this.lblCurrentTimeColorSample.setText(formatColor(config.getCurrentTimeBackColor()));
		this.lblSelectedTaskRowSample.setText(formatColor(config.getSelectionColor()));
	}


	public Config getConfig() {
		return config;
	}


	public void setConfig(Config config) {
		this.config = config;
	}


	/*
	 * 
	 */
	private String formatColor(Color color){
		return color.getRed() + ", " + color.getGreen() + ", "  + color.getBlue();
	}

}  //  @jve:decl-index=0:visual-constraint="9,9"
