package com.yuxingwang.gantt.demo.tabs;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.HeadlessException;
import java.awt.Rectangle;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * 
 * @author Yuxing Wang
 *
 */
public class MessageDialog extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static Frame frame = null;
	private JPanel jPanel = null;
	private JLabel lblMessage = null;
	private JButton btnOK = null;
	
	public MessageDialog() throws HeadlessException {
		super(frame, true);
		initialize();
	}

	public MessageDialog(Frame owner) throws HeadlessException {
		super(frame, true);
		initialize();
	}
	
	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(524, 173));
        this.setContentPane(getJPanel());
			
	}

	public void showMessage(String msg){
		this.lblMessage.setText(msg);
		this.setVisible(true);
	}


	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			lblMessage = new JLabel();
			lblMessage.setBounds(new Rectangle(23, 24, 463, 62));
			lblMessage.setText("JLabel");
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.add(lblMessage, null);
			jPanel.add(getBtnOK(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes btnOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new JButton();
			btnOK.setBounds(new Rectangle(185, 99, 107, 31));
			btnOK.setText("OK");
			btnOK.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					setVisible(false);
				}
			});
		}
		return btnOK;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
