package com.yuxingwang.gantt.demo.tabs;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerListModel;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;

import org.apache.commons.io.FilenameUtils;

import com.yuxingwang.gantt.Config;
import com.yuxingwang.gantt.GanttChart;
import com.yuxingwang.gantt.common.EventLogger;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 * @deprecated to com.yuxingwang.gantt.demo.tab.MiscTab
 */
public class MiscTab extends JPanel {

	private Config miscConfig = null;  //  @jve:decl-index=0:
	private GanttChart gantt = null;
	private static final long serialVersionUID = 1L;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel8;
	private JCheckBox ckbAllowTaskbarExcees;
	private JLabel jLabel12;
	private JSpinner jSpinner4;
	private JLabel jLabel11;
	private JSpinner jSpinner3;
	private JLabel jLabel10;
	private JSpinner jSpinner2;
	private JLabel jLabel9;
	private JLabel jLabel6;
	private JSpinner jSpinner1;
	private JLabel jLabel5 = null;
	private JSlider sldTimeUnitWidth = null;
	private JSlider sldGanttChartRowHeight = null;
	private JSlider sldTaskBarHeight = null;
	private JSlider sldProgressBarHeight = null;
	private JSlider sldBlankStepsToKickoffTime = null;
	private JSlider sldBlankStepsToDeadline = null;
	private JCheckBox ckbShowTaskInfoBehindTaskBar = null;
	private JLabel lblTimeUnitWidth = null;
	private JLabel lblRowHeight = null;
	private JLabel lblTaskBarHeight = null;
	private JLabel lblProgressBarHeight = null;
	private JLabel lblBlankStepsToKickoffTime = null;
	private JLabel lblBlankStepsToDeadline = null;
	private JTextField txtImagePath = null;
	private JButton btnChoose = null;
	private JButton btnGenerateImage = null;
	private JLabel jLabel7 = null;
	private JCheckBox ckbShowTreeView = null;

	/**
	 * This method initializes 
	 * 
	 */
	public MiscTab() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		jLabel7 = new JLabel();
		jLabel7.setBounds(10, 229, 240, 27);
		jLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel7.setText("Generate image file from Gantt chart");
		lblBlankStepsToDeadline = new JLabel();
		lblBlankStepsToDeadline.setBounds(new Rectangle(220, 174, 29, 18));
		lblBlankStepsToDeadline.setText("0");
		lblBlankStepsToDeadline.setHorizontalAlignment(SwingConstants.RIGHT);
		lblBlankStepsToKickoffTime = new JLabel();
		lblBlankStepsToKickoffTime.setBounds(new Rectangle(220, 142, 29, 18));
		lblBlankStepsToKickoffTime.setText("0");
		lblBlankStepsToKickoffTime.setHorizontalAlignment(SwingConstants.RIGHT);
		lblProgressBarHeight = new JLabel();
		lblProgressBarHeight.setBounds(new Rectangle(220, 110, 29, 18));
		lblProgressBarHeight.setText("0");
		lblProgressBarHeight.setHorizontalAlignment(SwingConstants.RIGHT);
		lblTaskBarHeight = new JLabel();
		lblTaskBarHeight.setBounds(new Rectangle(220, 78, 29, 18));
		lblTaskBarHeight.setText("0");
		lblTaskBarHeight.setHorizontalAlignment(SwingConstants.RIGHT);
		lblRowHeight = new JLabel();
		lblRowHeight.setBounds(new Rectangle(220, 46, 29, 18));
		lblRowHeight.setText("0");
		lblRowHeight.setHorizontalAlignment(SwingConstants.RIGHT);
		lblTimeUnitWidth = new JLabel();
		lblTimeUnitWidth.setBounds(new Rectangle(220, 14, 29, 18));
		lblTimeUnitWidth.setText("0");
		lblTimeUnitWidth.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel5 = new JLabel();
		jLabel5.setBounds(new Rectangle(17, 173, 189, 25));
		jLabel5.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel5.setText("The blank steps to deadline");
		jLabel4 = new JLabel();
		jLabel4.setBounds(new Rectangle(17, 140, 189, 25));
		jLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel4.setText("The blank steps to kickoff time");
		jLabel3 = new JLabel();
		jLabel3.setBounds(new Rectangle(17, 107, 189, 25));
		jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel3.setText("The height of the progress bar");
		jLabel2 = new JLabel();
		jLabel2.setBounds(new Rectangle(17, 74, 189, 25));
		jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel2.setText("The height of the task bar");
		jLabel1 = new JLabel();
		jLabel1.setBounds(new Rectangle(17, 41, 189, 25));
		jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel1.setText("The height of gantt chart row");
		jLabel = new JLabel();
		jLabel.setBounds(new Rectangle(17, 8, 189, 25));
		jLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		jLabel.setText("The width of the time unit");
		this.setLayout(null);
		this.setSize(new Dimension(782, 283));
		this.setPreferredSize(new java.awt.Dimension(827, 283));
		this.add(jLabel, null);
		this.add(jLabel1, null);
		this.add(jLabel2, null);
		this.add(jLabel3, null);
		this.add(jLabel4, null);
		this.add(jLabel5, null);
		this.add(getSldTimeUnitWidth(), null);
		this.add(getSldGanttChartRowHeight(), null);
		this.add(getSldTaskBarHeight(), null);
		this.add(getSldProgressBarHeight(), null);
		this.add(getSldBlankStepsToKickoffTime(), null);
		this.add(getSldBlankStepsToDeadline(), null);
		this.add(getCkbShowTaskInfoBehindTaskBar(), null);
		this.add(lblTimeUnitWidth, null);
		this.add(lblRowHeight, null);
		this.add(lblTaskBarHeight, null);
		this.add(lblProgressBarHeight, null);
		this.add(lblBlankStepsToKickoffTime, null);
		this.add(lblBlankStepsToDeadline, null);
		this.add(getTxtImagePath(), null);
		this.add(getBtnChoose(), null);
		this.add(getBtnGenerateImage(), null);
		this.add(jLabel7, null);
		this.add(getCkbShowTreeView(), null);
		this.add(getJSpinner1());
		this.add(getJLabel6());
		this.add(getJLabel8());
		this.add(getJLabel9());
		this.add(getJSpinner2());
		this.add(getJLabel10());
		this.add(getJSpinner3());
		this.add(getJLabel11());
		this.add(getJSpinner4());
		this.add(getJLabel12());
		this.add(getCkbAllowTaskbarExcees());

	}

	/**
	 * This method initializes sldTimeUnitWidth	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldTimeUnitWidth() {
		if (sldTimeUnitWidth == null) {
			sldTimeUnitWidth = new JSlider();
			sldTimeUnitWidth.setBounds(new Rectangle(269, 7, 165, 21));
			sldTimeUnitWidth.setValue(24);
			sldTimeUnitWidth.setMinimum(8);
			sldTimeUnitWidth.setMaximum(64);
			sldTimeUnitWidth.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldTimeUnitWidth.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setTimeUnitWidth(sldTimeUnitWidth.getValue());
						lblTimeUnitWidth.setText(miscConfig.getTimeUnitWidth() + "");
						System.out.println("Change time unit width to " + miscConfig.getTimeUnitWidth());
					}
				}
			});
		}
		return sldTimeUnitWidth;
	}

	/**
	 * This method initializes sldGanttChartRowHeight	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldGanttChartRowHeight() {
		if (sldGanttChartRowHeight == null) {
			sldGanttChartRowHeight = new JSlider();
			sldGanttChartRowHeight.setBounds(new Rectangle(269, 40, 165, 21));
			sldGanttChartRowHeight.setValue(24);
			sldGanttChartRowHeight.setMinimum(16);
			sldGanttChartRowHeight.setPaintLabels(false);
			sldGanttChartRowHeight.setPaintTicks(false);
			sldGanttChartRowHeight.setMaximum(48);
			sldGanttChartRowHeight.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldGanttChartRowHeight.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setGanttChartRowHeight(getSldGanttChartRowHeight().getValue());
						lblRowHeight.setText(miscConfig.getGanttChartRowHeight() + "");
					}
				}
			});
		}
		return sldGanttChartRowHeight;
	}

	/**
	 * This method initializes sldTaskBarHeight	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldTaskBarHeight() {
		if (sldTaskBarHeight == null) {
			sldTaskBarHeight = new JSlider();
			sldTaskBarHeight.setBounds(new Rectangle(269, 73, 165, 21));
			sldTaskBarHeight.setValue(16);
			sldTaskBarHeight.setMinimum(12);
			sldTaskBarHeight.setMaximum(36);
			sldTaskBarHeight.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldTaskBarHeight.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setTaskBarHeight(getSldTaskBarHeight().getValue());
						lblTaskBarHeight.setText(miscConfig.getTaskBarHeight() + "");
					}
				}
			});
		}
		return sldTaskBarHeight;
	}

	/**
	 * This method initializes sldProgressBarHeight	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldProgressBarHeight() {
		if (sldProgressBarHeight == null) {
			sldProgressBarHeight = new JSlider();
			sldProgressBarHeight.setBounds(new Rectangle(269, 106, 165, 21));
			sldProgressBarHeight.setValue(8);
			sldProgressBarHeight.setMinimum(6);
			sldProgressBarHeight.setMaximum(18);
			sldProgressBarHeight.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldProgressBarHeight.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setProgresBarHeight(getSldProgressBarHeight().getValue());
						lblProgressBarHeight.setText(miscConfig.getProgressBarHeight() + "");
					}
				}
			});
		}
		return sldProgressBarHeight;
	}

	/**
	 * This method initializes sldEmptyStepsToKickoffTime	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldBlankStepsToKickoffTime() {
		if (sldBlankStepsToKickoffTime == null) {
			sldBlankStepsToKickoffTime = new JSlider();
			sldBlankStepsToKickoffTime.setBounds(new Rectangle(269, 139, 165, 21));
			sldBlankStepsToKickoffTime.setValue(2);
			sldBlankStepsToKickoffTime.setMinimum(1);
			sldBlankStepsToKickoffTime.setMaximum(10);
			sldBlankStepsToKickoffTime.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldBlankStepsToKickoffTime.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setBlankStepsToKickoffTime(getSldBlankStepsToKickoffTime().getValue());
						lblBlankStepsToKickoffTime.setText(miscConfig.getBlankStepsToKickoffTime() + "");
					}
				}
			});
		}
		return sldBlankStepsToKickoffTime;
	}

	/**
	 * This method initializes sldEmptyStepsToDeadline	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSldBlankStepsToDeadline() {
		if (sldBlankStepsToDeadline == null) {
			sldBlankStepsToDeadline = new JSlider();
			sldBlankStepsToDeadline.setBounds(new Rectangle(269, 172, 165, 21));
			sldBlankStepsToDeadline.setMinimum(5);
			sldBlankStepsToDeadline.setValue(10);
			sldBlankStepsToDeadline.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (!sldBlankStepsToDeadline.getValueIsAdjusting()) {
						EventLogger.event(e, "stateChanged()");
						miscConfig.setBlankStepsToDeadline(getSldBlankStepsToDeadline().getValue());
						lblBlankStepsToDeadline.setText(miscConfig.getBlankStepsToDeadline() + "");
					}
				}
			});
		}
		return sldBlankStepsToDeadline;
	}

	/**
	 * This method initializes ckbShowTaskInfoBehindTaskBar	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getCkbShowTaskInfoBehindTaskBar() {
		if (ckbShowTaskInfoBehindTaskBar == null) {
			ckbShowTaskInfoBehindTaskBar = new JCheckBox();
			ckbShowTaskInfoBehindTaskBar.setBounds(new Rectangle(511, 15, 201, 26));
			ckbShowTaskInfoBehindTaskBar.setSelected(true);
			ckbShowTaskInfoBehindTaskBar.setText("Show Task Information");
			ckbShowTaskInfoBehindTaskBar.addItemListener(new java.awt.event.ItemListener() {

				public void itemStateChanged(java.awt.event.ItemEvent e) {
					EventLogger.event(e, "ckbShowTaskInfoBehindTaskBar.itemStateChanged()");
					miscConfig.setShowTaskInfoBehindTaskBar(getCkbShowTaskInfoBehindTaskBar().isSelected());
				}
			});
		}
		return ckbShowTaskInfoBehindTaskBar;
	}

	public Config getMiscConfig() {
		return miscConfig;
	}

	public void setMiscConfig(Config config) {
		this.miscConfig = config;

		this.lblTimeUnitWidth.setText(this.miscConfig.getTimeUnitWidth() + "");
		this.lblRowHeight.setText(this.miscConfig.getGanttChartRowHeight() + "");
		this.lblTaskBarHeight.setText(this.miscConfig.getTaskBarHeight() + "");
		this.lblProgressBarHeight.setText(this.miscConfig.getProgressBarHeight() + "");
		this.lblBlankStepsToKickoffTime.setText(this.miscConfig.getBlankStepsToKickoffTime() + "");
		this.lblBlankStepsToDeadline.setText(this.miscConfig.getBlankStepsToDeadline() + "");


		this.sldTimeUnitWidth.setValue(this.miscConfig.getTimeUnitWidth());
		this.sldGanttChartRowHeight.setValue(this.miscConfig.getGanttChartRowHeight());
		this.sldTaskBarHeight.setValue(this.miscConfig.getTaskBarHeight());
		this.sldProgressBarHeight.setValue(this.miscConfig.getProgressBarHeight());
		this.sldBlankStepsToKickoffTime.setValue(this.miscConfig.getBlankStepsToKickoffTime());
		this.sldBlankStepsToDeadline.setValue(this.miscConfig.getBlankStepsToDeadline());
		this.ckbShowTaskInfoBehindTaskBar.setSelected(this.miscConfig.isShowTaskInfoBehindTaskBar());
	}

	/**
	 * This method initializes txtImagePath	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTxtImagePath() {
		if (txtImagePath == null) {
			txtImagePath = new JTextField();
			txtImagePath.setBounds(271, 229, 300, 28);
		}
		return txtImagePath;
	}

	/**
	 * This method initializes btnChoose	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnChoose() {
		if (btnChoose == null) {
			btnChoose = new JButton();
			btnChoose.setBounds(583, 228, 92, 29);
			btnChoose.setText("Choose");
			btnChoose.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					JFileChooser chooser = new JFileChooser();
					File currrentDir = new File(System.getProperty("user.dir") + "/image");
					System.out.println(currrentDir);
					chooser.setCurrentDirectory(currrentDir);
					chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
					chooser.addChoosableFileFilter(new ImageFileFilter());
					int returnVal = chooser.showOpenDialog(null);
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						getTxtImagePath().setText(chooser.getSelectedFile().getAbsolutePath());
						System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());
					}

				}
			});
		}
		return btnChoose;
	}

	class ImageFileFilter extends FileFilter {

		@Override
		public boolean accept(File f) {
			if (f.isDirectory()) {
				return true;
			}
			String ext = FilenameUtils.getExtension(f.getName());
			if (ext.equals("png") || ext.equals("jpg")) {
				return true;
			}
			return false;
		}

		@Override
		public String getDescription() {
			return "Image Files(*.png, *.jpg)";
		}
	}

	/**
	 * This method initializes btnGenerateImage	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnGenerateImage() {
		if (btnGenerateImage == null) {
			btnGenerateImage = new JButton();
			btnGenerateImage.setBounds(681, 228, 92, 29);
			btnGenerateImage.setText("Generate");
			btnGenerateImage.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					String filePath = getTxtImagePath().getText();
					try {
						getGantt().generateImageFile(filePath);
					} catch (IOException e1) {
						e1.printStackTrace();
						MessageDialog msgDlg = new MessageDialog();
						msgDlg.showMessage("Error generationg image file for the Gantt chart.");
					}
				}
			});
		}
		return btnGenerateImage;
	}

	public GanttChart getGantt() {
		return gantt;
	}

	public void setGantt(GanttChart gantt) {
		this.gantt = gantt;
	}

	/**
	 * This method initializes ckbShowTreeView	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getCkbShowTreeView() {
		if (ckbShowTreeView == null) {
			ckbShowTreeView = new JCheckBox();
			ckbShowTreeView.setBounds(new Rectangle(511, 46, 201, 26));
			ckbShowTreeView.setSelected(true);
			ckbShowTreeView.setText("Show Task Tree View");
			ckbShowTreeView.addItemListener(new java.awt.event.ItemListener() {

				public void itemStateChanged(java.awt.event.ItemEvent e) {
					System.out.println("itemStateChanged()");
					gantt.setShowTreeView(ckbShowTreeView.isSelected());
				}
			});
		}
		return ckbShowTreeView;
	}

	private JSpinner getJSpinner1() {
		if (jSpinner1 == null) {
			SpinnerListModel jSpinner1Model =
					new SpinnerListModel(
					new String[]{"1", "2", "3", "4", "5", "6", "7"});
			jSpinner1Model.setValue("2");
			jSpinner1 = new JSpinner();
			jSpinner1.setModel(jSpinner1Model);
			jSpinner1.setBounds(610, 196, 36, 22);
			getJSpinner1().getEditor().setPreferredSize(new java.awt.Dimension(14, 18));
			getJSpinner1().getEditor().setPreferredSize(new java.awt.Dimension(14, 18));
			jSpinner1.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent evt) {
					System.out.println("jSpinner1.stateChanged, event=" + evt);
					JSpinner thisJSpinner = (JSpinner) evt.getSource();
					int start = Integer.parseInt(thisJSpinner.getValue().toString());
					int end = Integer.parseInt(getJSpinner2().getValue().toString());
					if (start >= end) {
						//Reset
						jSpinner1.getModel().setValue(end - 1);
//						jSpinner1.setValue(end - 1);
					}
					if (start < end) {
						GanttChart.getStaticConfig().setWorkingDaysSpanOfWeek(new int[]{start, end});
					}
				}
			});
		}
		return jSpinner1;
	}

	private JLabel getJLabel6() {
		if (jLabel6 == null) {
			jLabel6 = new JLabel();
			jLabel6.setText("Working day span of week:");
			jLabel6.setBounds(511, 167, 223, 15);
		}
		return jLabel6;
	}

	private JLabel getJLabel8() {
		if (jLabel8 == null) {
			jLabel8 = new JLabel();
			jLabel8.setText("From:");
			jLabel8.setBounds(558, 200, 42, 15);
		}
		return jLabel8;
	}

	private JLabel getJLabel9() {
		if (jLabel9 == null) {
			jLabel9 = new JLabel();
			jLabel9.setText("to");
			jLabel9.setBounds(654, 200, 42, 15);
		}
		return jLabel9;
	}

	private JSpinner getJSpinner2() {
		if (jSpinner2 == null) {
			SpinnerListModel jSpinner2Model =
					new SpinnerListModel(
					new String[]{"1", "2", "3", "4", "5", "6", "7"});
			jSpinner2Model.setValue("6");
			jSpinner2 = new JSpinner();
			jSpinner2.setModel(jSpinner2Model);
			jSpinner2.setBounds(692, 196, 36, 22);
			jSpinner2.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent evt) {
					System.out.println("jSpinner2.stateChanged, event=" + evt);
					JSpinner thisJSpinner = (JSpinner) evt.getSource();
					int start = Integer.parseInt(getJSpinner1().getValue().toString());
					int end = Integer.parseInt(thisJSpinner.getValue().toString());
					if (start >= end) {
						//Reset
						jSpinner2.getModel().setValue(end - 1);
					}
					if (start < end) {
						GanttChart.getStaticConfig().setWorkingDaysSpanOfWeek(new int[]{start, end});
					}
				}
			});
		}
		return jSpinner2;
	}

	private JLabel getJLabel10() {
		if (jLabel10 == null) {
			jLabel10 = new JLabel();
			jLabel10.setText("Working hour span of day:");
			jLabel10.setBounds(511, 114, 277, 15);
		}
		return jLabel10;
	}

	private JSpinner getJSpinner3() {
		if (jSpinner3 == null) {
			SpinnerListModel jSpinner3Model =
					new SpinnerListModel(new String[]{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10",
						"11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23"});
			jSpinner3Model.setValue("16");
			jSpinner3 = new JSpinner();
			jSpinner3.setModel(jSpinner3Model);
			jSpinner3.setBounds(691, 138, 36, 22);
			jSpinner3.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent evt) {
					System.out.println("jSpinner3.stateChanged, event=" + evt);
					JSpinner thisJSpinner = (JSpinner) evt.getSource();
					int start = Integer.parseInt(getJSpinner4().getValue().toString());
					int end = Integer.parseInt(thisJSpinner.getValue().toString());
					if (start >= end) {
						//Reset
						jSpinner4.setValue(end - 1);
					}
					if (start < end) {
						GanttChart.getStaticConfig().setWorkingHoursSpanOfDay(new int[]{start, end});
					}
				}
			});
		}
		return jSpinner3;
	}

	private JLabel getJLabel11() {
		if (jLabel11 == null) {
			jLabel11 = new JLabel();
			jLabel11.setText("to");
			jLabel11.setBounds(654, 142, 42, 15);
		}
		return jLabel11;
	}

	private JSpinner getJSpinner4() {
		if (jSpinner4 == null) {
			SpinnerListModel jSpinner4Model = new SpinnerListModel(new String[]{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10",
						"11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23"});
			jSpinner4Model.setValue("9");
			jSpinner4 = new JSpinner();
			jSpinner4.setModel(jSpinner4Model);
			jSpinner4.setBounds(610, 138, 36, 22);
			jSpinner4.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent evt) {
					System.out.println("jSpinner4.stateChanged, event=" + evt);
					JSpinner thisJSpinner = (JSpinner) evt.getSource();
					int start = Integer.parseInt(thisJSpinner.getValue().toString());
					int end = Integer.parseInt(getJSpinner3().getValue().toString());
					if (start >= end) {
						//Reset
						jSpinner4.setValue(end - 1);
					}
					if (start < end) {
						GanttChart.getStaticConfig().setWorkingHoursSpanOfDay(new int[]{start, end});
					}
				}
			});
		}
		return jSpinner4;
	}

	private JLabel getJLabel12() {
		if (jLabel12 == null) {
			jLabel12 = new JLabel();
			jLabel12.setText("From:");
			jLabel12.setBounds(558, 142, 42, 15);
		}
		return jLabel12;
	}

	private JCheckBox getCkbAllowTaskbarExcees() {
		if (ckbAllowTaskbarExcees == null) {
			ckbAllowTaskbarExcees = new JCheckBox();
			ckbAllowTaskbarExcees.setText("Allow Accurate Task Bar");
			ckbAllowTaskbarExcees.setSelected(true);
			ckbAllowTaskbarExcees.setBounds(511, 74, 201, 26);
			ckbAllowTaskbarExcees.addItemListener(new ItemListener() {

				public void itemStateChanged(ItemEvent e) {
					EventLogger.event(e, "ckbAllowTaskbarExcees.itemStateChanged()");
					GanttChart.getStaticConfig().setAllowAccurateTaskBar(ckbAllowTaskbarExcees.isSelected());
				}
			});
		}
		return ckbAllowTaskbarExcees;
	}
}  //  @jve:decl-index=0:visual-constraint="8,9"
