package com.yuxingwang.gantt.demo.tabs;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Calendar;

import javax.swing.BorderFactory;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;

import com.yuxingwang.gantt.common.CalendarUtils;
import com.yuxingwang.gantt.common.Constants;
import com.yuxingwang.gantt.common.EventLogger;
import com.yuxingwang.gantt.model.Task;

import datechooser.beans.DateChooserDialog;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Before use this dialog, you must set the static field frame first.
 * 
 * @author AlleNny
 * @deprecated to com.yuxingwang.gantt.demo.tab.TaskDialog
 */
public class TaskDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private Task task = null; //  @jve:decl-index=0:

	// use these 2 field to avoid parse time string from textfield.
	private Calendar inputedStartTime = null;

	private Calendar inputedEndTime = null;
	private JComboBox cmbStartHour;
	private JComboBox cmbEndHour;
	private JComboBox cmbStartMinute;
	private JComboBox cmbEndMinute;

	// Set the frame to your parent window frame to show a modal dialog.
	public static Frame frame = null;

	private JPanel jPanel = null;
	private JTextField txtTaskName = null;
	private JTextField txtDescription = null;
	private JTextField txtTaskStartTime = null;
	private JTextField txtTaskEndTime = null;
	private JTextField txtDuration = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel lblEndHour;
	private JLabel lblStartHour;
	private JLabel jLabel5 = null;
	private JTextField txtProgress = null;
	private JButton btnOK = null;
	private JButton btnCancel = null;
	private JLabel jLabel6 = null;

	private JButton btnPickStartTime = null;

	private JButton btnPickEndTime = null;

	/**
	 * This method initializes
	 * 
	 */
	public TaskDialog() {
		super(frame, true);
		initialize();
		task = new Task();
	}

	public TaskDialog(Task task) {
		super(frame, true);
		initialize();
		this.task = (Task) task.clone();
		this.txtTaskName.setText(task.getName());
		this.txtDescription.setText(task.getDescription());
		this.txtTaskStartTime.setText(DateFormatUtils.format(task.getStart().getTime(), Constants.TIME_FORMAT_YYYY_MM_DD_SLASH));
		this.txtTaskEndTime.setText(DateFormatUtils.format(task.getEnd().getTime(), Constants.TIME_FORMAT_YYYY_MM_DD_SLASH));
		this.txtDuration.setText(String.valueOf(task.getDuration()));
		this.txtProgress.setText(String.valueOf(task.getProgress()));
		int startHour = task.getStart().get(Calendar.HOUR_OF_DAY);
		int endHour = task.getEnd().get(Calendar.HOUR_OF_DAY);
		this.cmbStartHour.setSelectedIndex(startHour);
		this.cmbEndHour.setSelectedIndex(endHour);
		this.cmbStartMinute.setSelectedIndex(task.getStart().get(Calendar.MINUTE));
		this.cmbEndMinute.setSelectedIndex(task.getEnd().get(Calendar.MINUTE));
		// init time
		this.inputedStartTime = this.task.getStart();
		this.inputedEndTime = this.task.getEnd();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setSize(new Dimension(586, 280));
		this.setContentPane(getJPanel());

	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel6 = new JLabel();
			jLabel6.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jLabel6.setLocation(new Point(1, 199));
			jLabel6.setSize(new Dimension(526, 1));
			jLabel6.setText("");
			jLabel5 = new JLabel();
			jLabel5.setBounds(new Rectangle(191, 157, 100, 18));
			jLabel5.setText("Progress");
			jLabel4 = new JLabel();
			jLabel4.setBounds(new Rectangle(10, 157, 100, 18));
			jLabel4.setEnabled(false);
			jLabel4.setText("Duration:");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new Rectangle(10, 122, 100, 18));
			jLabel3.setText("End Time:");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new Rectangle(10, 87, 100, 18));
			jLabel2.setText("Start Time:");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new Rectangle(10, 52, 100, 18));
			jLabel1.setText("Description:");
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(10, 17, 100, 18));
			jLabel.setText("Task Name:");
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.add(getTxtTaskName(), null);
			jPanel.add(getTxtDescription(), null);
			jPanel.add(getTxtTaskStartTime(), null);
			jPanel.add(getTxtTaskEndTime(), null);
			jPanel.add(getTxtDuration(), null);
			jPanel.add(jLabel, null);
			jPanel.add(jLabel1, null);
			jPanel.add(jLabel2, null);
			jPanel.add(jLabel3, null);
			jPanel.add(jLabel4, null);
			jPanel.add(jLabel5, null);
			jPanel.add(getTxtProgress(), null);
			jPanel.add(getBtnOK(), null);
			jPanel.add(getBtnCancel(), null);
			jPanel.add(jLabel6, null);
			jPanel.add(getBtnPickStartTime(), null);
			jPanel.add(getBtnPickEndTime(), null);
			jPanel.add(getLblStartHour());
			jPanel.add(getLblEndHour());
			jPanel.add(getCmbStartHour());
			jPanel.add(getCmbEndHour());
			jPanel.add(getCmbStartMinute());
			jPanel.add(getCmbEndMinute());
		}
		return jPanel;
	}

	/**
	 * This method initializes txtTaskName
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtTaskName() {
		if (txtTaskName == null) {
			txtTaskName = new JTextField();
			txtTaskName.setBounds(new Rectangle(130, 17, 200, 22));
			txtTaskName.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setName(txtTaskName.getText());
				}
			});
		}
		return txtTaskName;
	}

	/**
	 * This method initializes txtDescription
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtDescription() {
		if (txtDescription == null) {
			txtDescription = new JTextField();
			txtDescription.setBounds(130, 51, 383, 22);
			txtDescription.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setDescription(txtDescription.getText());
				}
			});
		}
		return txtDescription;
	}

	/**
	 * This method initializes txtTaskStartTime
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtTaskStartTime() {
		if (txtTaskStartTime == null) {
			txtTaskStartTime = new JTextField();
			txtTaskStartTime.setBounds(130, 87, 109, 22);
			txtTaskStartTime.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setStart(Calendar.getInstance());
				}
			});
		}
		return txtTaskStartTime;
	}

	/**
	 * This method initializes txtTaskEndTime
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtTaskEndTime() {
		if (txtTaskEndTime == null) {
			txtTaskEndTime = new JTextField();
			txtTaskEndTime.setBounds(130, 122, 109, 22);
			txtTaskEndTime.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setEnd(Calendar.getInstance());
				}
			});
		}
		return txtTaskEndTime;
	}

	/**
	 * This method initializes txtDuration
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtDuration() {
		if (txtDuration == null) {
			txtDuration = new JTextField();
			txtDuration.setBounds(new Rectangle(130, 157, 46, 22));
			txtDuration.setEditable(false);
			txtDuration.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setDuration(Integer.parseInt(txtDuration.getText()));
				}
			});
		}
		return txtDuration;
	}

	/**
	 * This method initializes txtProgress
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtProgress() {
		if (txtProgress == null) {
			txtProgress = new JTextField();
			txtProgress.setBounds(new Rectangle(311, 157, 46, 22));
			txtProgress.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					EventLogger.event(e, "keyTyped()"); // TODO Auto-generated Event stub keyTyped()
					//					taskModel.setEffort(Integer.parseInt(txtEffort.getText()));
				}
			});
		}
		return txtProgress;
	}

	/**
	 * This method initializes btnOK
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new JButton();
			btnOK.setLocation(new Point(146, 213));
			btnOK.setText("OK");
			btnOK.setSize(new Dimension(75, 24));
			btnOK.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()"); 
					task.setName(txtTaskName.getText());
					task.setDescription(txtDescription.getText());
					task.setStart(inputedStartTime);
					task.setEnd(inputedEndTime);
					task.setProgress(NumberUtils.toInt(txtProgress.getText()));
					setVisible(false);
				}
			});
		}
		return btnOK;
	}

	/**
	 * This method initializes btnCancel
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnCancel() {
		if (btnCancel == null) {
			btnCancel = new JButton();
			btnCancel.setBounds(new Rectangle(255, 213, 75, 24));
			btnCancel.setText("Cancel");
			btnCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()"); 
					setVisible(false);
				}
			});
		}
		return btnCancel;
	}

	public Task getTask() {
		return task;
	}

	public void setTask(Task task) {
		this.task = task;
	}

	/**
	 * This method initializes btnPickStartTime
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnPickStartTime() {
		if (btnPickStartTime == null) {
			btnPickStartTime = new JButton();
			btnPickStartTime.setBounds(245, 87, 73, 22);
			btnPickStartTime.setText("Choose");
			btnPickStartTime.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()"); 
					DateChooserDialog dc = new DateChooserDialog();
					dc.setSelectedDate(inputedStartTime);
					dc.showDialog(frame, true);
					inputedStartTime = dc.getCurrent();
					CalendarUtils.truncateTime(inputedStartTime, Calendar.HOUR);
					txtTaskStartTime.setText(DateFormatUtils.format(inputedStartTime.getTime(), Constants.TIME_FORMAT_YYYY_MM_DD_SLASH));
				}
			});
		}
		return btnPickStartTime;
	}

	/**
	 * This method initializes btnPickEndTime
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnPickEndTime() {
		if (btnPickEndTime == null) {
			btnPickEndTime = new JButton();
			btnPickEndTime.setBounds(245, 122, 73, 22);
			btnPickEndTime.setText("Choose");
			btnPickEndTime.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()"); 
					DateChooserDialog dc = new DateChooserDialog();
					dc.setSelectedDate(inputedEndTime);
					dc.showDialog(frame, true);
					inputedEndTime = dc.getCurrent();
					CalendarUtils.truncateTime(inputedEndTime, Calendar.HOUR);
					txtTaskEndTime.setText(DateFormatUtils.format(inputedEndTime.getTime(), Constants.TIME_FORMAT_YYYY_MM_DD_SLASH));
				}
			});
		}
		return btnPickEndTime;
	}
	
	private JLabel getLblStartHour() {
		if(lblStartHour == null) {
			lblStartHour = new JLabel();
			lblStartHour.setText("Time:");
			lblStartHour.setBounds(348, 90, 43, 15);
		}
		return lblStartHour;
	}
	
	private JLabel getLblEndHour() {
		if(lblEndHour == null) {
			lblEndHour = new JLabel();
			lblEndHour.setText("Time:");
			lblEndHour.setBounds(348, 125, 43, 15);
		}
		return lblEndHour;
	}
	
	private JComboBox getCmbStartHour() {
		if(cmbStartHour == null) {
			String[] hours = new String[24];
			for(int i=0;i<24;i++){
				hours[i] = String.valueOf(i);
			}
			ComboBoxModel cmbStartHourModel = 
				new DefaultComboBoxModel(hours);
			cmbStartHour = new JComboBox();
			cmbStartHour.setModel(cmbStartHourModel);
			cmbStartHour.setBounds(416, 86, 46, 23);
			cmbStartHour.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent evt) {
					System.out.println("cmbStartHour.itemStateChanged, event="+evt);
					if( inputedStartTime == null){
						return;
					}
					int hour = cmbStartHour.getSelectedIndex();
					inputedStartTime.set(Calendar.HOUR_OF_DAY, hour);
				}
			});
		}
		return cmbStartHour;
	}
	
	private JComboBox getCmbEndHour() {
		if(cmbEndHour == null) {
			String[] hours = new String[24];
			for(int i=0;i<24;i++){
				hours[i] = String.valueOf(i);
			}
			ComboBoxModel cmbEndHourModel = 
				new DefaultComboBoxModel(hours);
			cmbEndHour = new JComboBox();
			cmbEndHour.setModel(cmbEndHourModel);
			cmbEndHour.setBounds(416, 121, 46, 23);
			cmbEndHour.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent evt) {
					System.out.println("cmbEndHour.itemStateChanged, event="+evt);
					if( inputedEndTime == null){
						return;
					}
					int hour = cmbEndHour.getSelectedIndex();
					inputedEndTime.set(Calendar.HOUR_OF_DAY, hour);
				}
			});
		}
		return cmbEndHour;
	}


	public JComboBox getCmbStartMinute() {
		if(cmbStartMinute == null) {
			String[] hours = new String[60];
			for(int i=0;i<60;i++){
				hours[i] = String.valueOf(i);
			}
			ComboBoxModel cmbStartMinuteModel =
				new DefaultComboBoxModel(hours);
			cmbStartMinute = new JComboBox();
			cmbStartMinute.setModel(cmbStartMinuteModel);
			cmbStartMinute.setBounds(486, 86, 46, 23);
			cmbStartMinute.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent evt) {
					System.out.println("cmbStartMinute.itemStateChanged, event="+evt);
					if( inputedStartTime == null){
						return;
					}
					int minute = cmbStartMinute.getSelectedIndex();
					inputedStartTime.set(Calendar.MINUTE, minute);
				}
			});
		}
		return cmbStartMinute;
	}

	public JComboBox getCmbEndMinute() {
		if(cmbEndMinute == null) {
			String[] minutes = new String[60];
			for(int i=0;i<60;i++){
				minutes[i] = String.valueOf(i);
			}
			ComboBoxModel cmbEndMinuteModel =
				new DefaultComboBoxModel(minutes);
			cmbEndMinute = new JComboBox();
			cmbEndMinute.setModel(cmbEndMinuteModel);
			cmbEndMinute.setBounds(486, 121, 46, 23);
			cmbEndMinute.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent evt) {
					System.out.println("cmbEndMinute.itemStateChanged, event="+evt);
					if( inputedEndTime == null){
						return;
					}
					int minute = cmbEndMinute.getSelectedIndex();
					inputedEndTime.set(Calendar.MINUTE, minute);
				}
			});
		}
		return cmbEndMinute;
	}





	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new TaskDialog().setVisible(true);
			}
		});
	}

}
